// XmlConf.h: interface for the CXmlConf class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XMLCONF_H__06C4D915_28FB_468F_A881_B843E10EAE39__INCLUDED_)
#define AFX_XMLCONF_H__06C4D915_28FB_468F_A881_B843E10EAE39__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CXmlConf  
{
public:

	struct SharedBuffer
	{
		char* pBuffer;
		int bufferSize;
		int   refcount;


		void Delete()
		{
			refcount--;
			if (refcount==0)
			{
				delete []pBuffer;
				delete this;
			}
		}
	};
	//
	// Constructor that gets the XML strings from the given file with the name
	// of 'fileName'.
	//
	CXmlConf(const char* fileName);

	//
	// Constructors that get the XML strings from the 'Buffer'. 
	// If the bAssigned is true, the 'Buffer' can be directly used inside. 
	// If the bAssigned is false, the CXmlConf object has to allocate the
	// internal memory and copy the data from 'Buffer'.
	//
	// Obviously, the former way is more efficent, however, users has to maintain
	// the 'Buffer' when using CXmlConf object.
	CXmlConf (char* begin, char* end); 

	//
	// ACCESSORS
	//
	inline operator bool() const {return m_bValid;}
	inline bool IsValid() const {return m_bValid;}
	inline CElement* GetRoot() const {return IsValid()? m_pRoot: NULL;}

	friend ostream& operator<<(ostream&os, CXmlConf const& obj);
	CXmlConf(CXmlConf const&);
	CXmlConf& operator= (CXmlConf const&);

	virtual ~CXmlConf();

private:
	//
	// Hide the default constuctor. Copy constructor and operator=
	//
	CXmlConf();

	bool Parse(char*p, int size);

	bool m_bValid;
	CElement *  m_pRoot;
	SharedBuffer* m_pBuffer;
	CScanner *m_pScanner;
};

#endif // !defined(AFX_XMLCONF_H__06C4D915_28FB_468F_A881_B843E10EAE39__INCLUDED_)
